<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>ZooKeeperSaslClient.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.client</a> &gt; <span class="el_source">ZooKeeperSaslClient.java</span></div><h1>ZooKeeperSaslClient.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.client;

import java.io.IOException;
import java.security.Principal;
import java.security.PrivilegedActionException;
import java.security.PrivilegedExceptionAction;

import javax.security.auth.Subject;
import javax.security.auth.callback.Callback;
import javax.security.auth.callback.CallbackHandler;
import javax.security.auth.callback.NameCallback;
import javax.security.auth.callback.PasswordCallback;
import javax.security.auth.callback.UnsupportedCallbackException;
import javax.security.auth.login.AppConfigurationEntry;
import javax.security.auth.login.Configuration;
import javax.security.auth.login.LoginException;
import javax.security.sasl.AuthorizeCallback;
import javax.security.sasl.RealmCallback;
import javax.security.sasl.Sasl;
import javax.security.sasl.SaslClient;
import javax.security.sasl.SaslException;

import org.apache.zookeeper.AsyncCallback;
import org.apache.zookeeper.ClientCnxn;
import org.apache.zookeeper.Environment;
import org.apache.zookeeper.Login;
import org.apache.zookeeper.Watcher.Event.KeeperState;
import org.apache.zookeeper.ZooDefs;
import org.apache.zookeeper.data.Stat;
import org.apache.zookeeper.proto.GetSASLRequest;
import org.apache.zookeeper.proto.SetSASLResponse;
import org.apache.zookeeper.server.auth.KerberosName;
import org.ietf.jgss.GSSContext;
import org.ietf.jgss.GSSCredential;
import org.ietf.jgss.GSSException;
import org.ietf.jgss.GSSManager;
import org.ietf.jgss.Oid;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * This class manages SASL authentication for the client. It
 * allows ClientCnxn to authenticate using SASL with a Zookeeper server.
 */
public class ZooKeeperSaslClient {
    public static final String LOGIN_CONTEXT_NAME_KEY = &quot;zookeeper.sasl.clientconfig&quot;;
    public static final String ENABLE_CLIENT_SASL_KEY = &quot;zookeeper.sasl.client&quot;;
    public static final String ENABLE_CLIENT_SASL_DEFAULT = &quot;true&quot;;

    /**
     * Returns true if the SASL client is enabled. By default, the client
     * is enabled but can be disabled by setting the system property
     * &lt;code&gt;zookeeper.sasl.client&lt;/code&gt; to &lt;code&gt;false&lt;/code&gt;. See
     * ZOOKEEPER-1657 for more information.
     *
     * @return If the SASL client is enabled.
     */
    public static boolean isEnabled() {
<span class="fc" id="L77">        return Boolean.valueOf(System.getProperty(ENABLE_CLIENT_SASL_KEY, ENABLE_CLIENT_SASL_DEFAULT));</span>
    }

<span class="fc" id="L80">    private static final Logger LOG = LoggerFactory.getLogger(ZooKeeperSaslClient.class);</span>
<span class="fc" id="L81">    private static Login login = null;</span>
    private SaslClient saslClient;
<span class="fc" id="L83">    private boolean isSASLConfigured = true;</span>

<span class="fc" id="L85">    private byte[] saslToken = new byte[0];</span>

<span class="pc" id="L87">    public enum SaslState {</span>
<span class="fc" id="L88">        INITIAL,INTERMEDIATE,COMPLETE,FAILED</span>
    }

<span class="fc" id="L91">    private SaslState saslState = SaslState.INITIAL;</span>

<span class="fc" id="L93">    private boolean gotLastPacket = false;</span>
    /** informational message indicating the current configuration status */
    private final String configStatus;

    public SaslState getSaslState() {
<span class="fc" id="L98">        return saslState;</span>
    }

    public String getLoginContext() {
<span class="pc bpc" id="L102" title="1 of 2 branches missed.">        if (login != null)</span>
<span class="fc" id="L103">            return login.getLoginContextName();</span>
<span class="nc" id="L104">        return null;</span>
    }

    public ZooKeeperSaslClient(final String serverPrincipal)
<span class="fc" id="L108">            throws LoginException {</span>
        /**
         * ZOOKEEPER-1373: allow system property to specify the JAAS
         * configuration section that the zookeeper client should use.
         * Default to &quot;Client&quot;.
         */
<span class="fc" id="L114">        String clientSection = System.getProperty(ZooKeeperSaslClient.LOGIN_CONTEXT_NAME_KEY, &quot;Client&quot;);</span>
        // Note that 'Configuration' here refers to javax.security.auth.login.Configuration.
<span class="fc" id="L116">        AppConfigurationEntry entries[] = null;</span>
<span class="fc" id="L117">        RuntimeException runtimeException = null;</span>
        try {
<span class="fc" id="L119">            entries = Configuration.getConfiguration().getAppConfigurationEntry(clientSection);</span>
<span class="nc" id="L120">        } catch (SecurityException e) {</span>
            // handle below: might be harmless if the user doesn't intend to use JAAS authentication.
<span class="nc" id="L122">            runtimeException = e;</span>
<span class="nc" id="L123">        } catch (IllegalArgumentException e) {</span>
            // third party customized getAppConfigurationEntry could throw IllegalArgumentException when JAAS
            // configuration isn't set. We can reevaluate whether to catch RuntimeException instead when more 
            // different types of RuntimeException found
<span class="nc" id="L127">            runtimeException = e;</span>
<span class="pc" id="L128">        }</span>
<span class="fc bfc" id="L129" title="All 2 branches covered.">        if (entries != null) {</span>
<span class="fc" id="L130">            this.configStatus = &quot;Will attempt to SASL-authenticate using Login Context section '&quot; + clientSection + &quot;'&quot;;</span>
<span class="fc" id="L131">            this.saslClient = createSaslClient(serverPrincipal, clientSection);</span>
        } else {
            // Handle situation of clientSection's being null: it might simply because the client does not intend to 
            // use SASL, so not necessarily an error.
<span class="fc" id="L135">            saslState = SaslState.FAILED;</span>
<span class="fc" id="L136">            String explicitClientSection = System.getProperty(ZooKeeperSaslClient.LOGIN_CONTEXT_NAME_KEY);</span>
<span class="fc bfc" id="L137" title="All 2 branches covered.">            if (explicitClientSection != null) {</span>
                // If the user explicitly overrides the default Login Context, they probably expected SASL to
                // succeed. But if we got here, SASL failed.
<span class="pc bpc" id="L140" title="1 of 2 branches missed.">                if (runtimeException != null) {</span>
<span class="nc" id="L141">                    throw new LoginException(&quot;Zookeeper client cannot authenticate using the &quot; + explicitClientSection +</span>
                            &quot; section of the supplied JAAS configuration: '&quot; +
<span class="nc" id="L143">                            System.getProperty(Environment.JAAS_CONF_KEY) + &quot;' because of a &quot; +</span>
                            &quot;RuntimeException: &quot; + runtimeException);
                } else {
<span class="fc" id="L146">                    throw new LoginException(&quot;Client cannot SASL-authenticate because the specified JAAS configuration &quot; +</span>
                            &quot;section '&quot; + explicitClientSection + &quot;' could not be found.&quot;);
                }
            } else {
                // The user did not override the default context. It might be that they just don't intend to use SASL,
                // so log at INFO, not WARN, since they don't expect any SASL-related information.
<span class="fc" id="L152">                String msg = &quot;Will not attempt to authenticate using SASL &quot;;</span>
<span class="pc bpc" id="L153" title="1 of 2 branches missed.">                if (runtimeException != null) {</span>
<span class="nc" id="L154">                    msg += &quot;(&quot; + runtimeException + &quot;)&quot;;</span>
                } else {
<span class="fc" id="L156">                    msg += &quot;(unknown error)&quot;;</span>
                }
<span class="fc" id="L158">                this.configStatus = msg;</span>
<span class="fc" id="L159">                this.isSASLConfigured = false;</span>
            }
<span class="pc bpc" id="L161" title="1 of 2 branches missed.">            if (System.getProperty(Environment.JAAS_CONF_KEY)  != null) {</span>
                // Again, the user explicitly set something SASL-related, so they probably expected SASL to succeed.
<span class="nc bnc" id="L163" title="All 2 branches missed.">                if (runtimeException != null) {</span>
<span class="nc" id="L164">                    throw new LoginException(&quot;Zookeeper client cannot authenticate using the '&quot; +</span>
<span class="nc" id="L165">                            System.getProperty(ZooKeeperSaslClient.LOGIN_CONTEXT_NAME_KEY, &quot;Client&quot;) +</span>
                            &quot;' section of the supplied JAAS configuration: '&quot; +
<span class="nc" id="L167">                            System.getProperty(Environment.JAAS_CONF_KEY) + &quot;' because of a &quot; +</span>
                            &quot;RuntimeException: &quot; + runtimeException);
                } else {
<span class="nc" id="L170">                    throw new LoginException(&quot;No JAAS configuration section named '&quot; +</span>
<span class="nc" id="L171">                            System.getProperty(ZooKeeperSaslClient.LOGIN_CONTEXT_NAME_KEY, &quot;Client&quot;) +</span>
                            &quot;' was found in specified JAAS configuration file: '&quot; +
<span class="nc" id="L173">                            System.getProperty(Environment.JAAS_CONF_KEY) + &quot;'.&quot;);</span>
                }
            }
        }
<span class="fc" id="L177">    }</span>
    
    /**
     * @return informational message indicating the current configuration status.
     */
    public String getConfigStatus() {
<span class="fc" id="L183">        return configStatus;</span>
    }

    public boolean isComplete() {
<span class="fc bfc" id="L187" title="All 2 branches covered.">        return (saslState == SaslState.COMPLETE);</span>
    }

    public boolean isFailed() {
<span class="fc bfc" id="L191" title="All 2 branches covered.">        return (saslState == SaslState.FAILED);</span>
    }

<span class="fc" id="L194">    public static class ServerSaslResponseCallback implements AsyncCallback.DataCallback {</span>
        public void processResult(int rc, String path, Object ctx, byte data[], Stat stat) {
            // processResult() is used by ClientCnxn's sendThread to respond to
            // data[] contains the Zookeeper Server's SASL token.
            // ctx is the ZooKeeperSaslClient object. We use this object's respondToServer() method
            // to reply to the Zookeeper Server's SASL token
<span class="nc" id="L200">            ZooKeeperSaslClient client = ((ClientCnxn)ctx).zooKeeperSaslClient;</span>
<span class="nc bnc" id="L201" title="All 2 branches missed.">            if (client == null) {</span>
<span class="nc" id="L202">                LOG.warn(&quot;sasl client was unexpectedly null: cannot respond to Zookeeper server.&quot;);</span>
<span class="nc" id="L203">                return;</span>
            }
<span class="nc" id="L205">            byte[] usedata = data;</span>
<span class="nc bnc" id="L206" title="All 2 branches missed.">            if (data != null) {</span>
<span class="nc" id="L207">                LOG.debug(&quot;ServerSaslResponseCallback(): saslToken server response: (length=&quot;+usedata.length+&quot;)&quot;);</span>
            }
            else {
<span class="nc" id="L210">                usedata = new byte[0];</span>
<span class="nc" id="L211">                LOG.debug(&quot;ServerSaslResponseCallback(): using empty data[] as server response (length=&quot;+usedata.length+&quot;)&quot;);</span>
            }
<span class="nc" id="L213">            client.respondToServer(usedata, (ClientCnxn)ctx);</span>
<span class="nc" id="L214">        }</span>
    }

    synchronized private SaslClient createSaslClient(final String servicePrincipal,
                                                     final String loginContext) throws LoginException {
        try {
<span class="fc bfc" id="L220" title="All 2 branches covered.">            if (login == null) {</span>
<span class="pc bpc" id="L221" title="1 of 2 branches missed.">                if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L222">                    LOG.debug(&quot;JAAS loginContext is: &quot; + loginContext);</span>
                }
                // note that the login object is static: it's shared amongst all zookeeper-related connections.
                // createSaslClient() must be declared synchronized so that login is initialized only once.
<span class="fc" id="L226">                login = new Login(loginContext, new ClientCallbackHandler(null));</span>
<span class="fc" id="L227">                login.startThreadIfNeeded();</span>
            }
<span class="fc" id="L229">            Subject subject = login.getSubject();</span>
            SaslClient saslClient;
            // Use subject.getPrincipals().isEmpty() as an indication of which SASL mechanism to use:
            // if empty, use DIGEST-MD5; otherwise, use GSSAPI.
<span class="pc bpc" id="L233" title="1 of 2 branches missed.">            if (subject.getPrincipals().isEmpty()) {</span>
                // no principals: must not be GSSAPI: use DIGEST-MD5 mechanism instead.
<span class="fc" id="L235">                LOG.info(&quot;Client will use DIGEST-MD5 as SASL mechanism.&quot;);</span>
<span class="fc" id="L236">                String[] mechs = {&quot;DIGEST-MD5&quot;};</span>
<span class="fc" id="L237">                String username = (String)(subject.getPublicCredentials().toArray()[0]);</span>
<span class="fc" id="L238">                String password = (String)(subject.getPrivateCredentials().toArray()[0]);</span>
                // &quot;zk-sasl-md5&quot; is a hard-wired 'domain' parameter shared with zookeeper server code (see ServerCnxnFactory.java)
<span class="fc" id="L240">                saslClient = Sasl.createSaslClient(mechs, username, &quot;zookeeper&quot;, &quot;zk-sasl-md5&quot;, null, new ClientCallbackHandler(password));</span>
<span class="fc" id="L241">                return saslClient;</span>
            }
            else { // GSSAPI.
<span class="nc" id="L244">            	boolean usingNativeJgss =</span>
<span class="nc" id="L245">            			Boolean.getBoolean(&quot;sun.security.jgss.native&quot;);</span>
<span class="nc bnc" id="L246" title="All 2 branches missed.">            	if (usingNativeJgss) {</span>
            		// http://docs.oracle.com/javase/6/docs/technotes/guides/security/jgss/jgss-features.html
            		// &quot;&quot;&quot;
            		// In addition, when performing operations as a particular
            		// Subject, e.g. Subject.doAs(...) or Subject.doAsPrivileged(...),
            		// the to-be-used GSSCredential should be added to Subject's
            		// private credential set. Otherwise, the GSS operations will
            		// fail since no credential is found.
            		// &quot;&quot;&quot;
            		try {
<span class="nc" id="L256">            			GSSManager manager = GSSManager.getInstance();</span>
<span class="nc" id="L257">            			Oid krb5Mechanism = new Oid(&quot;1.2.840.113554.1.2.2&quot;);</span>
<span class="nc" id="L258">            			GSSCredential cred = manager.createCredential(null,</span>
            					GSSContext.DEFAULT_LIFETIME,
            					krb5Mechanism,
            					GSSCredential.INITIATE_ONLY);
<span class="nc" id="L262">            			subject.getPrivateCredentials().add(cred);</span>
<span class="nc bnc" id="L263" title="All 2 branches missed.">            			if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L264">            				LOG.debug(&quot;Added private credential to subject: &quot; + cred);</span>
            			}
<span class="nc" id="L266">            		} catch (GSSException ex) {</span>
<span class="nc" id="L267">            			LOG.warn(&quot;Cannot add private credential to subject; &quot; +</span>
            					&quot;authentication at the server may fail&quot;, ex);
<span class="nc" id="L269">            		}</span>
            	}
<span class="nc" id="L271">                final Object[] principals = subject.getPrincipals().toArray();</span>
                // determine client principal from subject.
<span class="nc" id="L273">                final Principal clientPrincipal = (Principal)principals[0];</span>
<span class="nc" id="L274">                final KerberosName clientKerberosName = new KerberosName(clientPrincipal.getName());</span>
                // assume that server and client are in the same realm (by default; unless the system property
                // &quot;zookeeper.server.realm&quot; is set).
<span class="nc" id="L277">                String serverRealm = System.getProperty(&quot;zookeeper.server.realm&quot;,clientKerberosName.getRealm());</span>
<span class="nc" id="L278">                KerberosName serviceKerberosName = new KerberosName(servicePrincipal+&quot;@&quot;+serverRealm);</span>
<span class="nc" id="L279">                final String serviceName = serviceKerberosName.getServiceName();</span>
<span class="nc" id="L280">                final String serviceHostname = serviceKerberosName.getHostName();</span>
<span class="nc" id="L281">                final String clientPrincipalName = clientKerberosName.toString();</span>
                try {
<span class="nc" id="L283">                    saslClient = Subject.doAs(subject,new PrivilegedExceptionAction&lt;SaslClient&gt;() {</span>
                        public SaslClient run() throws SaslException {
<span class="nc" id="L285">                            LOG.info(&quot;Client will use GSSAPI as SASL mechanism.&quot;);</span>
<span class="nc" id="L286">                            String[] mechs = {&quot;GSSAPI&quot;};</span>
<span class="nc" id="L287">                            LOG.debug(&quot;creating sasl client: client=&quot;+clientPrincipalName+&quot;;service=&quot;+serviceName+&quot;;serviceHostname=&quot;+serviceHostname);</span>
<span class="nc" id="L288">                            SaslClient saslClient = Sasl.createSaslClient(mechs,clientPrincipalName,serviceName,serviceHostname,null,new ClientCallbackHandler(null));</span>
<span class="nc" id="L289">                            return saslClient;</span>
                        }
                    });
<span class="nc" id="L292">                    return saslClient;</span>
                }
<span class="nc" id="L294">                catch (Exception e) {</span>
<span class="nc" id="L295">                	LOG.error(&quot;Exception while trying to create SASL client&quot;, e);</span>
<span class="nc" id="L296">                    e.printStackTrace();</span>
<span class="nc" id="L297">                    return null;</span>
                }
            }
<span class="nc" id="L300">        } catch (LoginException e) {</span>
            // We throw LoginExceptions...
<span class="nc" id="L302">            throw e;</span>
<span class="nc" id="L303">        } catch (Exception e) {</span>
            // ..but consume (with a log message) all other types of exceptions.
<span class="nc" id="L305">            LOG.error(&quot;Exception while trying to create SASL client: &quot; + e);</span>
<span class="nc" id="L306">            return null;</span>
        }
    }

    public void respondToServer(byte[] serverToken, ClientCnxn cnxn) {
<span class="pc bpc" id="L311" title="1 of 2 branches missed.">        if (saslClient == null) {</span>
<span class="nc" id="L312">            LOG.error(&quot;saslClient is unexpectedly null. Cannot respond to server's SASL message; ignoring.&quot;);</span>
<span class="nc" id="L313">            return;</span>
        }

<span class="pc bpc" id="L316" title="1 of 2 branches missed.">        if (!(saslClient.isComplete())) {</span>
            try {
<span class="fc" id="L318">                saslToken = createSaslToken(serverToken);</span>
<span class="fc bfc" id="L319" title="All 2 branches covered.">                if (saslToken != null) {</span>
<span class="fc" id="L320">                    sendSaslPacket(saslToken, cnxn);</span>
                }
<span class="fc" id="L322">            } catch (SaslException e) {</span>
<span class="fc" id="L323">                LOG.error(&quot;SASL authentication failed using login context '&quot; +</span>
<span class="fc" id="L324">                        this.getLoginContext() + &quot;'.&quot;);</span>
<span class="fc" id="L325">                saslState = SaslState.FAILED;</span>
<span class="fc" id="L326">                gotLastPacket = true;</span>
<span class="fc" id="L327">            }</span>
        }

<span class="fc bfc" id="L330" title="All 2 branches covered.">        if (saslClient.isComplete()) {</span>
            // GSSAPI: server sends a final packet after authentication succeeds
            // or fails.
<span class="pc bpc" id="L333" title="3 of 4 branches missed.">            if ((serverToken == null) &amp;&amp; (saslClient.getMechanismName().equals(&quot;GSSAPI&quot;)))</span>
<span class="nc" id="L334">                gotLastPacket = true;</span>
            // non-GSSAPI: no final packet from server.
<span class="pc bpc" id="L336" title="1 of 2 branches missed.">            if (!saslClient.getMechanismName().equals(&quot;GSSAPI&quot;)) {</span>
<span class="fc" id="L337">                gotLastPacket = true;</span>
            }
            // SASL authentication is completed, successfully or not:
            // enable the socket's writable flag so that any packets waiting for authentication to complete in
            // the outgoing queue will be sent to the Zookeeper server.
<span class="fc" id="L342">            cnxn.enableWrite();</span>
        }
<span class="fc" id="L344">    }</span>

    private byte[] createSaslToken() throws SaslException {
<span class="nc" id="L347">        saslState = SaslState.INTERMEDIATE;</span>
<span class="nc" id="L348">        return createSaslToken(saslToken);</span>
    }

    private byte[] createSaslToken(final byte[] saslToken) throws SaslException {
<span class="fc bfc" id="L352" title="All 2 branches covered.">        if (saslToken == null) {</span>
            // TODO: introspect about runtime environment (such as jaas.conf)
<span class="fc" id="L354">            saslState = SaslState.FAILED;</span>
<span class="fc" id="L355">            throw new SaslException(&quot;Error in authenticating with a Zookeeper Quorum member: the quorum member's saslToken is null.&quot;);</span>
        }

<span class="fc" id="L358">        Subject subject = login.getSubject();</span>
<span class="pc bpc" id="L359" title="1 of 2 branches missed.">        if (subject != null) {</span>
<span class="fc" id="L360">            synchronized(login) {</span>
                try {
<span class="fc" id="L362">                    final byte[] retval =</span>
<span class="fc" id="L363">                        Subject.doAs(subject, new PrivilegedExceptionAction&lt;byte[]&gt;() {</span>
                                public byte[] run() throws SaslException {
<span class="fc" id="L365">                                    LOG.debug(&quot;saslClient.evaluateChallenge(len=&quot;+saslToken.length+&quot;)&quot;);</span>
<span class="fc" id="L366">                                    return saslClient.evaluateChallenge(saslToken);</span>
                                }
                            });
<span class="fc" id="L369">                    return retval;</span>
                }
<span class="nc" id="L371">                catch (PrivilegedActionException e) {</span>
<span class="nc" id="L372">                    String error = &quot;An error: (&quot; + e + &quot;) occurred when evaluating Zookeeper Quorum Member's &quot; +</span>
                      &quot; received SASL token.&quot;;
                    // Try to provide hints to use about what went wrong so they can fix their configuration.
                    // TODO: introspect about e: look for GSS information.
<span class="nc" id="L376">                    final String UNKNOWN_SERVER_ERROR_TEXT =</span>
                      &quot;(Mechanism level: Server not found in Kerberos database (7) - UNKNOWN_SERVER)&quot;;
<span class="nc bnc" id="L378" title="All 2 branches missed.">                    if (e.toString().indexOf(UNKNOWN_SERVER_ERROR_TEXT) &gt; -1) {</span>
<span class="nc" id="L379">                        error += &quot; This may be caused by Java's being unable to resolve the Zookeeper Quorum Member's&quot; +</span>
                          &quot; hostname correctly. You may want to try to adding&quot; +
                          &quot; '-Dsun.net.spi.nameservice.provider.1=dns,sun' to your client's JVMFLAGS environment.&quot;;
                    }
<span class="nc" id="L383">                    error += &quot; Zookeeper Client will go to AUTH_FAILED state.&quot;;</span>
<span class="nc" id="L384">                    LOG.error(error);</span>
<span class="nc" id="L385">                    saslState = SaslState.FAILED;</span>
<span class="nc" id="L386">                    throw new SaslException(error);</span>
                }
<span class="nc" id="L388">            }</span>
        }
        else {
<span class="nc" id="L391">            throw new SaslException(&quot;Cannot make SASL token without subject defined. &quot; +</span>
              &quot;For diagnosis, please look for WARNs and ERRORs in your log related to the Login class.&quot;);
        }
    }

    private void sendSaslPacket(byte[] saslToken, ClientCnxn cnxn)
      throws SaslException{
<span class="pc bpc" id="L398" title="1 of 2 branches missed.">        if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L399">            LOG.debug(&quot;ClientCnxn:sendSaslPacket:length=&quot;+saslToken.length);</span>
        }

<span class="fc" id="L402">        GetSASLRequest request = new GetSASLRequest();</span>
<span class="fc" id="L403">        request.setToken(saslToken);</span>
<span class="fc" id="L404">        SetSASLResponse response = new SetSASLResponse();</span>
<span class="fc" id="L405">        ServerSaslResponseCallback cb = new ServerSaslResponseCallback();</span>

        try {
<span class="fc" id="L408">            cnxn.sendPacket(request,response,cb, ZooDefs.OpCode.sasl);</span>
<span class="nc" id="L409">        } catch (IOException e) {</span>
<span class="nc" id="L410">            throw new SaslException(&quot;Failed to send SASL packet to server.&quot;,</span>
                e);
<span class="fc" id="L412">        }</span>
<span class="fc" id="L413">    }</span>

    private void sendSaslPacket(ClientCnxn cnxn) throws SaslException {
<span class="nc bnc" id="L416" title="All 2 branches missed.">        if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L417">            LOG.debug(&quot;ClientCnxn:sendSaslPacket:length=&quot;+saslToken.length);</span>
        }
<span class="nc" id="L419">        GetSASLRequest request = new GetSASLRequest();</span>
<span class="nc" id="L420">        request.setToken(createSaslToken());</span>
<span class="nc" id="L421">        SetSASLResponse response = new SetSASLResponse();</span>
<span class="nc" id="L422">        ServerSaslResponseCallback cb = new ServerSaslResponseCallback();</span>
        try {
<span class="nc" id="L424">            cnxn.sendPacket(request,response,cb, ZooDefs.OpCode.sasl);</span>
<span class="nc" id="L425">        } catch (IOException e) {</span>
<span class="nc" id="L426">            throw new SaslException(&quot;Failed to send SASL packet to server due &quot; +</span>
              &quot;to IOException:&quot;, e);
<span class="nc" id="L428">        }</span>
<span class="nc" id="L429">    }</span>

    // used by ClientCnxn to know whether to emit a SASL-related event: either AuthFailed or SaslAuthenticated,
    // or none, if not ready yet. Sets saslState to COMPLETE as a side-effect.
    public KeeperState getKeeperState() {
<span class="fc bfc" id="L434" title="All 2 branches covered.">        if (saslClient != null) {</span>
<span class="fc bfc" id="L435" title="All 2 branches covered.">            if (saslState == SaslState.FAILED) {</span>
<span class="fc" id="L436">              return KeeperState.AuthFailed;</span>
            }
<span class="fc bfc" id="L438" title="All 2 branches covered.">            if (saslClient.isComplete()) {</span>
<span class="fc bfc" id="L439" title="All 2 branches covered.">                if (saslState == SaslState.INTERMEDIATE) {</span>
<span class="fc" id="L440">                    saslState = SaslState.COMPLETE;</span>
<span class="fc" id="L441">                    return KeeperState.SaslAuthenticated;</span>
                }
            }
        }
        // No event ready to emit yet.
<span class="fc" id="L446">        return null;</span>
    }

    // Initialize the client's communications with the Zookeeper server by sending the server the first
    // authentication packet.
    public void initialize(ClientCnxn cnxn) throws SaslException {
<span class="pc bpc" id="L452" title="1 of 2 branches missed.">        if (saslClient == null) {</span>
<span class="nc" id="L453">            saslState = SaslState.FAILED;</span>
<span class="nc" id="L454">            throw new SaslException(&quot;saslClient failed to initialize properly: it's null.&quot;);</span>
        }
<span class="pc bpc" id="L456" title="1 of 2 branches missed.">        if (saslState == SaslState.INITIAL) {</span>
<span class="pc bpc" id="L457" title="1 of 2 branches missed.">            if (saslClient.hasInitialResponse()) {</span>
<span class="nc" id="L458">                sendSaslPacket(cnxn);</span>
            }
            else {
<span class="fc" id="L461">                byte[] emptyToken = new byte[0];</span>
<span class="fc" id="L462">                sendSaslPacket(emptyToken, cnxn);</span>
            }
<span class="fc" id="L464">            saslState = SaslState.INTERMEDIATE;</span>
        }
<span class="fc" id="L466">    }</span>

    // The CallbackHandler interface here refers to
    // javax.security.auth.callback.CallbackHandler.
    // It should not be confused with Zookeeper packet callbacks like
    //  org.apache.zookeeper.server.auth.SaslServerCallbackHandler.
    public static class ClientCallbackHandler implements CallbackHandler {
<span class="fc" id="L473">        private String password = null;</span>

<span class="fc" id="L475">        public ClientCallbackHandler(String password) {</span>
<span class="fc" id="L476">            this.password = password;</span>
<span class="fc" id="L477">        }</span>

        public void handle(Callback[] callbacks) throws
          UnsupportedCallbackException {
<span class="fc bfc" id="L481" title="All 2 branches covered.">            for (Callback callback : callbacks) {</span>
<span class="fc bfc" id="L482" title="All 2 branches covered.">                if (callback instanceof NameCallback) {</span>
<span class="fc" id="L483">                    NameCallback nc = (NameCallback) callback;</span>
<span class="fc" id="L484">                    nc.setName(nc.getDefaultName());</span>
<span class="fc" id="L485">                }</span>
                else {
<span class="fc bfc" id="L487" title="All 2 branches covered.">                    if (callback instanceof PasswordCallback) {</span>
<span class="fc" id="L488">                        PasswordCallback pc = (PasswordCallback)callback;</span>
<span class="pc bpc" id="L489" title="1 of 2 branches missed.">                        if (password != null) {</span>
<span class="fc" id="L490">                            pc.setPassword(this.password.toCharArray());</span>
                        } else {
<span class="nc" id="L492">                            LOG.warn(&quot;Could not login: the client is being asked for a password, but the Zookeeper&quot; +</span>
                              &quot; client code does not currently support obtaining a password from the user.&quot; +
                              &quot; Make sure that the client is configured to use a ticket cache (using&quot; +
                              &quot; the JAAS configuration setting 'useTicketCache=true)' and restart the client. If&quot; +
                              &quot; you still get this message after that, the TGT in the ticket cache has expired and must&quot; +
                              &quot; be manually refreshed. To do so, first determine if you are using a password or a&quot; +
                              &quot; keytab. If the former, run kinit in a Unix shell in the environment of the user who&quot; +
                              &quot; is running this Zookeeper client using the command&quot; +
                              &quot; 'kinit &lt;princ&gt;' (where &lt;princ&gt; is the name of the client's Kerberos principal).&quot; +
                              &quot; If the latter, do&quot; +
                              &quot; 'kinit -k -t &lt;keytab&gt; &lt;princ&gt;' (where &lt;princ&gt; is the name of the Kerberos principal, and&quot; +
                              &quot; &lt;keytab&gt; is the location of the keytab file). After manually refreshing your cache,&quot; +
                              &quot; restart this client. If you continue to see this message after manually refreshing&quot; +
                              &quot; your cache, ensure that your KDC host's clock is in sync with this host's clock.&quot;);
                        }
<span class="fc" id="L507">                    }</span>
                    else {
<span class="pc bpc" id="L509" title="1 of 2 branches missed.">                        if (callback instanceof RealmCallback) {</span>
<span class="fc" id="L510">                            RealmCallback rc = (RealmCallback) callback;</span>
<span class="fc" id="L511">                            rc.setText(rc.getDefaultText());</span>
<span class="fc" id="L512">                        }</span>
                        else {
<span class="nc bnc" id="L514" title="All 2 branches missed.">                            if (callback instanceof AuthorizeCallback) {</span>
<span class="nc" id="L515">                                AuthorizeCallback ac = (AuthorizeCallback) callback;</span>
<span class="nc" id="L516">                                String authid = ac.getAuthenticationID();</span>
<span class="nc" id="L517">                                String authzid = ac.getAuthorizationID();</span>
<span class="nc bnc" id="L518" title="All 2 branches missed.">                                if (authid.equals(authzid)) {</span>
<span class="nc" id="L519">                                    ac.setAuthorized(true);</span>
                                } else {
<span class="nc" id="L521">                                    ac.setAuthorized(false);</span>
                                }
<span class="nc bnc" id="L523" title="All 2 branches missed.">                                if (ac.isAuthorized()) {</span>
<span class="nc" id="L524">                                    ac.setAuthorizedID(authzid);</span>
                                }
<span class="nc" id="L526">                            }</span>
                            else {
<span class="nc" id="L528">                                throw new UnsupportedCallbackException(callback,&quot;Unrecognized SASL ClientCallback&quot;);</span>
                            }
                        }
                    }
                }
            }
<span class="fc" id="L534">        }</span>
    }

    public boolean clientTunneledAuthenticationInProgress() {
<span class="fc bfc" id="L538" title="All 2 branches covered.">    	if (!isSASLConfigured) {</span>
<span class="fc" id="L539">    	    return false;</span>
        } 
        // TODO: Rather than checking a disjunction here, should be a single member
        // variable or method in this class to determine whether the client is
        // configured to use SASL. (see also ZOOKEEPER-1455).
        try {
<span class="fc bfc" id="L545" title="All 2 branches covered.">  	    if ((System.getProperty(Environment.JAAS_CONF_KEY) != null) ||</span>
<span class="pc bpc" id="L546" title="1 of 2 branches missed.">              ((javax.security.auth.login.Configuration.getConfiguration() != null) &amp;&amp;</span>
<span class="fc" id="L547">                  (javax.security.auth.login.Configuration.getConfiguration().</span>
<span class="pc bpc" id="L548" title="1 of 2 branches missed.">                       getAppConfigurationEntry(System.</span>
<span class="fc" id="L549">                       getProperty(ZooKeeperSaslClient.LOGIN_CONTEXT_NAME_KEY,&quot;Client&quot;)) </span>
                           != null))) {
                // Client is configured to use a valid login Configuration, so
                // authentication is either in progress, successful, or failed.

                // 1. Authentication hasn't finished yet: we must wait for it to do so.
<span class="fc bfc" id="L555" title="All 2 branches covered.">                if ((isComplete() == false) &amp;&amp;</span>
<span class="fc bfc" id="L556" title="All 2 branches covered.">                    (isFailed() == false)) {</span>
<span class="fc" id="L557">                    return true;</span>
                }

                // 2. SASL authentication has succeeded or failed..
<span class="pc bpc" id="L561" title="1 of 4 branches missed.">                if (isComplete() || isFailed()) {</span>
<span class="pc bpc" id="L562" title="1 of 2 branches missed.">                    if (gotLastPacket == false) {</span>
                        // ..but still in progress, because there is a final SASL
                        // message from server which must be received.
<span class="nc" id="L565">                    return true;</span>
                    }
                }
            }
            // Either client is not configured to use a tunnelled authentication
            // scheme, or tunnelled authentication has completed (successfully or
            // not), and all server SASL messages have been received.
<span class="fc" id="L572">            return false;</span>
<span class="nc" id="L573">        } catch (SecurityException e) {</span>
            // Thrown if the caller does not have permission to retrieve the Configuration.
            // In this case, simply returning false is correct.
<span class="nc bnc" id="L576" title="All 2 branches missed.">            if (LOG.isDebugEnabled() == true) {</span>
<span class="nc" id="L577">                LOG.debug(&quot;Could not retrieve login configuration: &quot; + e);</span>
            }
<span class="nc" id="L579">            return false;</span>
        }
    }


}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>